#include <U8g2lib.h>
#include <U8x8lib.h>
#include <time.h> 

U8G2_ST7920_128X64_1_HW_SPI u8g2(U8G2_R0, /* CS=*/ 10, /* reset=*/ 8);

int button[5] = {1, 2, 3, 4, 5} ; 
int row = 0, col = 0;
char gameboard[3][3];
char move = 'X';
int nr_moves = 0;
char winner ='N';
int screen = 0;
char bot = 'N';

void initGame() {
  int i, j;
  
  move = 'X';
  col = 0;
  row = 0;
  nr_moves = 0;
  winner = 'N';
  
  for (i = 0; i < 3; i++) {
    for (j = 0; j < 3; j++) {
      gameboard[i][j] = '?'; 
    }
  } 
}

bool checkIfWin() {
  
  int i, j;
  
  for (i = 0; i < 3; i++) {
    // linii
    if (gameboard[i][0] == gameboard[i][1] && gameboard[i][0] == gameboard[i][2] && gameboard[i][0] != '?') {
      return true; 
    }
    // coloane
    if (gameboard[0][i] == gameboard[1][i] && gameboard[0][i] == gameboard[2][i] && gameboard[0][i] != '?') {
      return true; 
    } 
  }
  
  // diagonale
  if (gameboard[0][0] == gameboard[1][1] && gameboard[0][0] == gameboard[2][2] && gameboard[0][0] != '?') {
      return true; 
    }
  if (gameboard[0][2] == gameboard[1][1] && gameboard[0][2] == gameboard[2][0] && gameboard[0][2] != '?') {
    return true; 
  } 
  
  return false;
}

bool finishGame() {
  if (checkIfWin() == true) {
    Serial.print("finish game");
      winner = move;
      //initGame();
      delay(100);
      return true;
  } else if (nr_moves == 9) {
      winner = 'D';
      //initGame();
      delay(100);
      return true;
  }
  
  return false;
}


void setup () {
  Serial.begin(9600); 
  u8g2.begin();
  u8g2.enableUTF8Print();
  u8g2.setFont(u8g2_font_helvB10_tf); 
  u8g2.setColorIndex(1);  

  initGame();
}

void loop () {
  
  u8g2.firstPage();
  do {
    if (screen == 0) {
      screen_0();     
    } else if (screen == 1) {
      screen_1();
    } else if (screen == 2) {
      screen_2();
    } else if (screen == 3) {
      screen_3();
    }
  } while( u8g2.nextPage() );
}

void screen_0() {

  u8g2.setFont(u8g2_font_helvB10_tf);

  u8g2.drawFrame(0,0,128,64);

   u8g2.drawStr(30, 20, "1 vs Bot - 1");

   u8g2.drawLine(0, 30, 128, 30);

   u8g2.drawStr(30, 50, "1 vs 1 - 2");
  
   if (digitalRead(button[0]) == LOW) {
    screen = 1;
  }
  if (digitalRead(button[1]) == LOW) {
    screen = 3;
  }

  delay(200);
}

void screen_1() {
  u8g2.setFont(u8g2_font_helvB10_tf);

  u8g2.drawFrame(0,0,128,64);

   u8g2.drawStr(30, 20, "X - 1");

   u8g2.drawLine(0, 30, 128, 30);

   u8g2.drawStr(30, 50, "0 - 2");
  
   if (digitalRead(button[0]) == LOW) {
    bot = '0';
    screen = 2;
  }
  if (digitalRead(button[1]) == LOW) {
    bot = 'X';
    screen = 2;
  }

  delay(200);
}

void screen_2() {
  int i, j;
  bool ok = false;

  if (move == bot) {
    bool my_turn = true;

    
    srand(time(NULL));
    
    while (my_turn == true && winner == 'N') {
      int x = rand() % 3;
      int y = rand() % 3;

      if (gameboard[x][y] == '?') {
        gameboard[x][y] = move;
        nr_moves++;
        finishGame();
        my_turn = false;
        if (move == 'X')
          move = '0';
        else move = 'X';
        col = 0;
        row = 0;
      }
    }
  } else {
 
    if (digitalRead(button[0]) == LOW) {
      col--;
    }
    if (digitalRead(button[1]) == LOW) {
      col++;
    }
    if (digitalRead(button[2]) == LOW) {
      row--;
    }
    if (digitalRead(button[3]) == LOW) {
      row++;
    }
    if (digitalRead(button[4]) == LOW) {
      ok = true;
    }
   
    if (col >= 3)col = 2;
    if (col < 0) col = 0;
    if (row >= 3)row = 2;
    if (row < 0) row = 0;
    
    if (ok == true) {
      if (gameboard[row][col] == '?') {
        gameboard[row][col] = move;
        nr_moves++;
        finishGame();
        if (move == 'X')
          move = '0';
        else move = 'X';
        col = 0;
        row = 0;
      }
    }
  
  }
  if (winner == 'N') {
    // tabla de joc x si 0
    u8g2.drawFrame(0,0,128,64);
    
    // linii orizontale
    u8g2.drawLine(0, 21, 128, 21);
    u8g2.drawLine(0, 42, 128, 42);
    // linii verticale
    u8g2.drawLine(43, 0, 43, 64);
    u8g2.drawLine(86, 0, 86, 64);    

    int x, y = 0;
    
    for (i = 0; i < 3; i++) {
      y = y + 20;
      x = -25;
      for (j = 0; j < 3; j++) {
        x = x + 40;
        char c[1] = { gameboard[i][j] };
        if ( row == i && col == j) u8g2.setFont(u8g2_font_helvB10_tf);
        else u8g2.setFont(u8g2_font_ncenB14_tr);
        u8g2.drawStr(x, y, c);  
      }
    }

  } else {

    u8g2.drawFrame(0,0,128,31);
    u8g2.drawFrame(0,32,128,64);

    u8g2.setFont(u8g2_font_helvB10_tf);
    if (winner == 'D') {
      u8g2.drawStr(50, 20, "Draw");
    } else {
      if (winner == 'X') {
          if (bot == 'X')
            u8g2.drawStr(15, 20, "Winner: X bot");
          else u8g2.drawStr(15, 20, "Winner: X me");
      } else if (winner == '0') {
          if (bot == '0')
            u8g2.drawStr(15, 20, "Winner: 0 bot");
          else u8g2.drawStr(15, 20, "Winner: 0 me");
      }
    }
    

    u8g2.drawStr(15, 50, "Menu - 1, R - 2");

     if (digitalRead(button[0]) == LOW) {
      initGame();
      bot = 'N';
      screen = 0;

      delay(200);
    }
    if (digitalRead(button[1]) == LOW) {
      initGame();
      screen = 2;
    }
 
  }

  delay(100);
}

void screen_3(){
  int i, j;
  bool ok = false;
 
  if (digitalRead(button[0]) == LOW) {
    col--;
  }
  if (digitalRead(button[1]) == LOW) {
    col++;
  }
  if (digitalRead(button[2]) == LOW) {
    row--;
  }
  if (digitalRead(button[3]) == LOW) {
    row++;
  }
  if (digitalRead(button[4]) == LOW) {
    ok = true;
  }
 
  if (col >= 3)col = 2;
  if (col < 0) col = 0;
  if (row >= 3)row = 2;
  if (row < 0) row = 0;
  
  if (ok == true) {
    if (gameboard[row][col] == '?') {
      gameboard[row][col] = move;
      nr_moves++;
      finishGame();
      if (move == 'X')
        move = '0';
      else move = 'X';
      col = 0;
      row = 0;
    }
  }
  

  if (winner == 'N') {
    // tabla de joc x si 0
    u8g2.drawFrame(0,0,128,64);
    
    // linii orizontale
    u8g2.drawLine(0, 21, 128, 21);
    u8g2.drawLine(0, 42, 128, 42);
    // linii verticale
    u8g2.drawLine(43, 0, 43, 64);
    u8g2.drawLine(86, 0, 86, 64);    

    int x, y = 0;
    
    for (i = 0; i < 3; i++) {
      y = y + 20;
      x = -25;
      for (j = 0; j < 3; j++) {
        x = x + 40;
        char c[1] = { gameboard[i][j] };
        if ( row == i && col == j) u8g2.setFont(u8g2_font_helvB10_tf);
        else u8g2.setFont(u8g2_font_ncenB14_tr);
        u8g2.drawStr(x, y, c);  
      }
    }

  } else {

    u8g2.drawFrame(0,0,128,31);
    u8g2.drawFrame(0,32,128,64);

    u8g2.setFont(u8g2_font_helvB10_tf);
    if (winner == 'D') {
      u8g2.drawStr(50, 20, "Draw");
    } else {
      if (winner == 'X') {
        u8g2.drawStr(30, 20, "Winner: X");
      } else if (winner == '0') {
        u8g2.drawStr(30, 20, "Winner: 0");
      }
    }
    

    u8g2.drawStr(15, 50, "Menu - 1, R - 2");

     if (digitalRead(button[0]) == LOW) {
      initGame();
      screen = 0;
      delay(200);
    }
    if (digitalRead(button[1]) == LOW) {
      initGame();
      screen = 3;
    }
 
  }

  delay(100);
}
